/* 
 *  cl_lib.h -  rpc client support library interface
 *              of GNU SQL compiler
 *                
 *  This file is a part of GNU SQL Server
 *
 *  Copyright (c) 1996, 1997, Free Software Foundation, Inc
 *  Developed at the Institute of System Programming
 *  This file is written by Michael Kimelman 
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Contacts: gss@ispras.ru
 *
 */

/* $Id: cl_lib.h,v 1.245 1997/03/31 03:46:38 kml Exp $ */

#ifndef __CL_LIB_H__
#define __CL_LIB_H__

#include "setup_os.h"
#include "dispatch.h"

char *clnt_error_msg __P((void));

CLIENT *create_service __P((char *hostname,
		       rpc_svc_t required_service,
		       i4_t answer_wait_time, 
		       i4_t trn_client_wait_time,
		       i4_t total_transaction_time));

i4_t   svc_ready __P((CLIENT *cl_handle,
		i4_t min_delay,
		i4_t max_delay, 
		i4_t max_wait_time));

void  down_svc     __P((CLIENT *svc     ));
char *get_host     __P((CLIENT *cl      ));
char *choose_host  __P((char   *hostname));
char *SQL__err_msg __P((i4_t code));


#endif
