/*
 *  inpop.h  -  Answer codes of Storage and Transaction
 *              Synchronization Management System 
 *
 *  This file is a part of GNU SQL Server
 *
 *  Copyright (c) 1996, 1997, Free Software Foundation, Inc
 *  Developed at the Institute of System Programming
 *  This file is written by  Vera Ponomarenko
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 *
 *  Contacts:   gss@ispras.ru
 *
 */

#if !defined(__pupans_h__) && !defined(__PR_GLOB_H__)

#define __pupans_h__

/* $Id: pupans.h,v 1.245 1997/03/31 03:46:38 kml Exp $ */

enum {
  OK     =  0,       /* OK */
  NU     = -1,       /* The key of tnis tuple isn't unique */
  NCF    = -2,       /* Incorrect conditions */
  NDR    = -3,       /* Incorrect relation identifier */
  NMS    = -4,       /* Incorrect scan mode */
  NCR    = -5,       /* Current tuple is absent */
  NIOB   = -6,       /* Incorrect object identifier */
  NDSC   = -7,       /* Incorrect scan identifier */
  NDI    = -8,       /* Incorrect index identifier */
  N_SORT = -9,       /* Not sorted */
  H_DBL  = -10,      /* Has doublicates */
  D_DRCTN =-11,      /* Sort directions are not matched */
  N_EQV  = -12,      /* Objects are not equivalent */
  EMFL   = -13,      /* The filter is empty */
  EOSCAN = -14,      /* End of scan */
  NO_SUCH_SEG  = -15 /* No such segment */
};

#endif
